Loading...
Searching...
No Matches
decaf::SHA3< bits > Class Template Reference

Fixed-output-length SHA3. More...

`#include <shake.hxx>`

Inheritance diagram for decaf::SHA3< bits >:

## Public Member Functions

| SHA3 () DECAF_NOEXCEPT
| Initializer.
Public Member Functions inherited from decaf::KeccakHash
void | update (const uint8_t *__restrict__ in, size_t len) DECAF_NOEXCEPT
| Add more data to running hash.
void | update (const Block &s) DECAF_NOEXCEPT
| Add more data to running hash, C++ version.
KeccakHash & | operator<< (const Block &s) DECAF_NOEXCEPT
| Add more data, stream version.
KeccakHash & | operator+= (const Block &s) DECAF_NOEXCEPT
| Same as <<.
SecureBuffer | output (size_t len)
| Output bytes from the sponge.
SecureBuffer | final (size_t len)
| Output bytes from the sponge.
void | output (Buffer b)
| Output bytes from the sponge.
void | final (Buffer b)
| Output bytes from the sponge and reinitialize it.
size_t | default_output_size () const DECAF_NOEXCEPT
| Return the sponge's default output size.
size_t | max_output_size () const DECAF_NOEXCEPT
| Return the sponge's maximum output size.
SecureBuffer | output ()
| Output the default number of bytes.
SecureBuffer | final ()
| Output the default number of bytes, and reset hash.
void | reset () DECAF_NOEXCEPT
| Reset the hash to the empty string.
| ~KeccakHash () DECAF_NOEXCEPT
| Destructor zeroizes state.

## Static Public Member Functions

static SecureBuffer | hash (const Block &b, size_t nbytes=MAX_OUTPUT_BYTES)
| Hash bytes with this SHA3 instance.

## Static Public Attributes

static const size_t | MAX_OUTPUT_BYTES = bits/8
| Number of bytes of output.
static const size_t | DEFAULT_OUTPUT_BYTES = bits/8
| Number of bytes of output.

## Detailed Description

template<int bits>
class decaf::SHA3< bits >

Fixed-output-length SHA3.

## Member Function Documentation

## hash()

template<int bits>

static SecureBuffer decaf::SHA3< bits >::hash | ( | const Block & | b,
|  | size_t | nbytes = `MAX_OUTPUT_BYTES`
| ) |  |

inline static

Hash bytes with this SHA3 instance.

Exceptions

  LengthException | if nbytes > MAX_OUTPUT_BYTES

The documentation for this class was generated from the following file:

- src/GENERATED/include/decaf/shake.hxx